Getting Started with React Button Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/button/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { Button } from 'smart-webcomponents-react/button';

const App = () => {
  return (
    <div>
      <div className="demo-horizontal-layout">
        <div>
          <label>Default Buttons</label>
          <div className="demo-buttons-group">
            <Button>Normal</Button>
            <Button className="raised">Raised</Button>
            <Button className="outlined">Outlined</Button>
            <Button className="flat">Flat</Button>
            <Button className="floating">
              <span className="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon">
                <i className="material-icons">&#xE53F;</i>
              </span>
            </Button>
          </div>
        </div>
        <div>
          <label>Primary Buttons</label>
          <div className="demo-buttons-group">
            <Button className="primary">Normal</Button>
            <Button className="raised primary">Raised</Button>
            <Button className="outlined primary">Outlined</Button>
            <Button className="flat primary">Flat</Button>
            <Button className="floating primary">
              <span className="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon">
                <i className="material-icons">&#xE53F;</i>
              </span>
            </Button>
          </div>
        </div>
        <div>
          <label>Secondary Buttons</label>
          <div className="demo-buttons-group">
            <Button className="secondary">Normal</Button>
            <Button className="raised secondary">Raised</Button>
            <Button className="outlined secondary">Outlined</Button>
            <Button className="flat secondary">Flat</Button>
            <Button className="floating secondary">
              <span className="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon">
                <i className="material-icons">&#xE53F;</i>
              </span>
            </Button>
          </div>
        </div>
        <div>
          <label>Success Buttons</label>
          <div className="demo-buttons-group">
            <Button className="success">Normal</Button>
            <Button className="raised success">Raised</Button>
            <Button className="outlined success">Outlined</Button>
            <Button className="flat success">Flat</Button>
            <Button className="floating success">
              <span className="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon">
                <i className="material-icons">&#xE53F;</i>
              </span>
            </Button>
          </div>
        </div>
        <div>
          <label>Error Buttons</label>
          <div className="demo-buttons-group">
            <Button className="error">Normal</Button>
            <Button className="raised error">Raised</Button>
            <Button className="outlined error">Outlined</Button>
            <Button className="flat error">Flat</Button>
            <Button className="floating error">
              <span className="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon">
                <i className="material-icons">&#xE53F;</i>
              </span>
            </Button>
          </div>
        </div>
      </div>
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Button, ButtonProps } from 'smart-webcomponents-react/button';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Button component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Button - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/button/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ButtonModule from smart-webcomponents-angular/button: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ButtonModule } from 'smart-webcomponents-angular/button';

4 Root component (standalone)

Add ButtonModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, OnInit, AfterViewInit } from '@angular/core';

import { ButtonModule } from 'smart-webcomponents-angular/button';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ButtonModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-button as needed:

 <div class="demo-horizontal-layout">
    <div>
        <label>Default Buttons</label>
        <div class="demo-buttons-group">
            <smart-button>Normal</smart-button>
            <smart-button #button class="raised">Raised</smart-button>
            <smart-button #button2 class="outlined">Outlined</smart-button>
            <smart-button #button3 class="flat">Flat</smart-button>
            <smart-button #button4 class="floating"><span class="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon"><i class="material-icons">&#xE53F;</i></span>
            </smart-button>
        </div>
    </div>
    <div>
        <label>Primary Buttons</label>
        <div class="demo-buttons-group">
            <smart-button #button5 class="primary">Normal</smart-button>
            <smart-button #button6 class="raised primary">Raised</smart-button>
            <smart-button #button7 class="outlined primary">Outlined</smart-button>
            <smart-button #button8 class="flat primary">Flat</smart-button>
            <smart-button #button9 class="floating primary"><span class="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon"><i class="material-icons">&#xE53F;</i></span>
            </smart-button>
        </div>
    </div>
    <div>
        <label>Secondary Buttons</label>
        <div class="demo-buttons-group">
            <smart-button #button10 class="secondary">Normal</smart-button>
            <smart-button #button11 class="raised secondary">Raised</smart-button>
            <smart-button #button12 class="outlined secondary">Outlined</smart-button>
            <smart-button #button13 class="flat secondary">Flat</smart-button>
            <smart-button #button14 class="floating secondary"><span class="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon"><i class="material-icons">&#xE53F;</i></span>
            </smart-button>
        </div>
    </div>
    <div>
        <label>Success Buttons</label>
        <div class="demo-buttons-group">
            <smart-button #button15 class="success">Normal</smart-button>
            <smart-button #button16 class="raised success">Raised</smart-button>
            <smart-button #button17 class="outlined success">Outlined</smart-button>
            <smart-button #button18 class="flat success">Flat</smart-button>
            <smart-button #button19 class="floating success"><span class="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon"><i class="material-icons">&#xE53F;</i></span>
            </smart-button>
        </div>
    </div>
    <div>
        <label>Error Buttons</label>
        <div class="demo-buttons-group">
            <smart-button #button20 class="error">Normal</smart-button>
            <smart-button #button21 class="raised error">Raised</smart-button>
            <smart-button #button22 class="outlined error">Outlined</smart-button>
            <smart-button #button23 class="flat error">Flat</smart-button>
            <smart-button #button24 class="floating error"><span class="button-demo-icon demo-icon demo-device-icon-phone-portrait demo-button-demo-icon"><i class="material-icons">&#xE53F;</i></span>
            </smart-button>
        </div>
    </div>
</div>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ButtonModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ButtonModule from smart-webcomponents-angular/button on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ButtonModule } from 'smart-webcomponents-angular/button';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ButtonModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The Button component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.